//
// MyLibraryUser.jsx
// This script should be in the same folder as the document MyLibraryUserSourceCS3.indd
// It is automatically called by the MyLibraryUserController page item.
//

if (this.myOwnLibrary == undefined)
{
  var libraryPlugin = GetScriptedPlugin(theItem,"libraryplugin");
  libraryPlugin.handleScriptEvent("loadLibrary");
  alert("Library loaded");
}

this.myOwnLibrary.myfunction("test");

// ***************************

function GetDocumentFromChild(childItem)
{
  var parentDocument = null;
 
  do // do{}while(false); construct; bail out using 'break'
  {
    //
    // Climb the parent chain starting from the child until we cannot
    // go any further, or until we hit a 'Document' object
    //
    while 
    (
      childItem != null 
     &&
      childItem.parent != childItem 
     &&
      ! (childItem instanceof Document)
    )
    {
      childItem = childItem.parent;
    }

    if (! (childItem instanceof Document))
    {
      break; // bail out
    }
    
    parentDocument = childItem;
  }
  while (false);
 
  return parentDocument;
}

// ***************************

function GetScriptedPlugin(docOrPageItem,controllerName)
{
  //
  // This works together with the APIDTemplate - it either
  // finds the actual ScriptedPlugin object or the stand-in
  // proxy object in case we're running inside APIDTemplate
  // and the spln has not been compiled yet
  // Pass the proper controllerName to this e.g. if the 
  // Controller object in APIDTemplate is called "XYzProxy"
  // then the scripted plugin will be called "xyz" (all lowercase)
  // but you should pass "XYz" as the controllername to this
  // function.
  // That also means that the return value can be a TextFrame
  // instead of a ScriptedPlugin.
  //
  var scriptedPlugin = null;
  var err;
  try
  {
    do // do{}while(false); construct; bail out using 'break'
    {
      var document = GetDocumentFromChild(docOrPageItem);
      if (! (document instanceof Document))
      {
        break;
      }
  
      scriptedPlugin = document.loadedScriptedPlugins(controllerName.toLowerCase())[0];
      if (scriptedPlugin == null)
      {
        scriptedPlugin = theItem.labeledPageItems(controllerName + "Proxy")[0];
      }
    }
    while (false);
  }
  catch (err)
  {
    scriptedPlugin = null;
  }
  
  return scriptedPlugin;
}

